<?php

###############################################################################
#                 ALLbum-0.1.0: db_functions.inc.php                          #
#                 (SAS database functions component)                          #
#                                                                             #
# ALLbum-0.1.0 is a development version of the ALLbum gallery.                #
# It is also available as a module for the Content Management System          #
# "Site@School"  (http://siteatschool.sourceforge.net).                       #
#                                                                             #
# ALLbum is hosted at http://sasmodulesi.sourceforge.net                      #
# ALLbum is written by Martin Herrman <m.herrman@student.tue.nl>              #
# ALLbum is copyrighted by OBS Rosa Boekdrukker, Amsterdam, The Netherlands   #
# (http://www.rosaboekdrukker.nl)                                             #
# ALLbum is licenced by GNU General Public Licence                            #
#                                                                             #
###############################################################################
#                                                                             #
#                            LICENCE INFORMATION                              #
#                                                                             #
# Copyright (c) 2003, OBS Rosa Boekdrukker, Amsterdam, The Netherlands.       #
#                                                                             #
# This program is free software, you can redistribute it and/or               #
# modify it under the terms of the GNU General Public License                 #
# as published by the Free Software Foundation; either version 2              #
# of the License, or (at your option) any later version.                      #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        #
# See the GNU General Public License for more details.                        #
#                                                                             #
# You should hvae received a copy of the GNU General Public License           #
# along with this program; if not, write to the Free Software                 #
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. #
#                                                                             #
###############################################################################

# init:

// get Allbum table:
global $table_modules;
$query = "SELECT dbtables FROM " .$table_modules. " WHERE location='sn_allbum'";
$result = mysql_query($query) or die (mysql_error().$query);
$moduletables = mysql_result($result,0);
$moduletables = explode(",", $moduletables);
$allbum_table = $moduletables[0];

#### Used by sas_index.php ####

function db_GetPicSizeX()
{
  // Task: return the configuration option picsize_x
  global $table_configuration;
  $query = "SELECT config_value FROM $table_configuration WHERE config_key='allbum_picsize_x'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function db_GetVisibleContents($ID)
{
  // Task: return the id's for all objects that are
  // located in (sub)-album with id $ID.
  // Objects that are tagged hidden must not be returned.
  // When $ID = 0, return the id's of all main albums
  // Return the result in an array.

  global $allbum_table;
  
  if ($ID == 0) {
    $query = "SELECT id, hidden FROM $allbum_table WHERE type='album'";
    $result = mysql_query($query) or die (mysql_error().$query);
    $array = array();
    while ($temp = mysql_fetch_array($result)) {
	if ($temp[1] == 0) {
	    array_push($array, $temp[0]);
	}
    }
    return $array;
  } else {
    $query = "SELECT children FROM $allbum_table WHERE id='$ID'";
    $result = mysql_query($query) or die (mysql_error().$query);
    $result = mysql_result($result,0);
    $result = explode(",",$result);
    $visible_children = array();
    if ($result[0] == "") {
	return $visible_children;
    } else {
	foreach($result AS $key => $value) {
	    if (db_GetHidden($value) == 0) {
		array_push($visible_children, $value);
	    }
	}
	if ($visible_children[0] == "") {
	    $visible_children = array();
	}
	return $visible_children;
    }
  }

}

function db_GetMaxObjectsPerPage()
{
  // Task: return the configuration option max_objects_per_page
  global $table_configuration;
  $query = "SELECT config_value FROM $table_configuration WHERE config_key='allbum_max_objects_per_page'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function db_GetThumbSizeX()
{
  // Task: return the configuration option thumbsize_x
  global $table_configuration;
  $query = "SELECT config_value FROM $table_configuration WHERE config_key='allbum_thumbsize_x'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

###############################################################################

#### Used by sas_admin.php ####

function db_PutHideObject($ID)
{
  // Task: set hidden field for object with id $ID to 1
  global $allbum_table;
  $query = "UPDATE $allbum_table SET hidden = 1 WHERE id = '$ID'";
  $result = mysql_query($query) or die (mysql_error().$query);
}

function db_PutUnhideObject($ID)
{
  // Task: set hidden field for object with id $ID to 0
  global $allbum_table;
  $query = "UPDATE $allbum_table SET hidden = 0 WHERE id = '$ID'";
  $result = mysql_query($query) or die (mysql_error().$query);
}

function db_PutDeleteObjects($list)
{
  // Task: $list is a list which contains id's of objects that must
  // be deleted. Items in the list are seperated by a "," and the list
  // might start with a ",".
  // If an object is a (sub-)album and is not empty, all it's contents
  // must be deleted too.
  // Deletion = delete file(s) and/or directorie(s) and delete database
  // entrie(s). Don't forget to update the parent!
  // Note: a main album does not have a parent.

  $list = explode(",", $list);

  foreach ($list AS $key => $value) {
    if ($value != "") {
	
	$type = db_GetType($value);
	$parent = db_GetParentID($value);

	if ($type == "album") {
		DeleteContents($value);
		DeleteDirectory($value);
		RemoveDatabaseEntry($value);
		UpdateDatabaseAlbumOrd();
	} elseif ($type == "subalbum") {
		UpdateParentListOfChildren($value,$parent);
		DeleteContents($value);
		DeleteDirectory($value);
		RemoveDatabaseEntry($value);
		db_PutIfNeededUpdateParentThumb($parent);
	} else {
		UpdateParentListOfChildren($value,$parent);
		DeleteFiles($value);
		RemoveDatabaseEntry($value);
		db_PutIfNeededUpdateParentThumb($parent);
	}
        
	
    }
  }
}

function db_GetEmpty($id)
{
  // Task: for object with id $id, return "yes" if the object is empty,
  // return "no" otherwise. $id might be the id of an object that is not
  // a (sub-)album, in that case, return "yes".
  
  $type = db_GetType($id);
  if (($type != "subalbum") AND ($type != "album") ) {
    return "yes";
  } else {
    if (count(db_GetContents($id)) == 0) {
	return "yes";
    } else {
	return "no";
    }
  }
}

function db_GetTitle($ID)
{
  // Task: return title for object with id $ID
  
  global $allbum_table;
  
  $query = "SELECT title FROM $allbum_table WHERE id='$ID'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function db_GetAlbumExists($title, $id)
{
  // Task: return true if sub-album with title $title exists in sub-album
  // with id $id.
  // When $id = -1 return true if a main album with title $title exists.
  
  global $allbum_table;
  
  if ($id == -1) {
    $query = "SELECT title FROM $allbum_table WHERE type='album'";
  } else {
    $query = "SELECT title FROM $allbum_table WHERE type='subalbum' AND parents LIKE '%" .trim($id). "%'";
  }
  $result = mysql_query($query) or die (mysql_error().$query);
  $array1 = array();
  while ($array2 = mysql_fetch_row($result)) {
    array_push($array1,$array2[0]);
  }
  $result = in_array($title,$array1);
  return $result;
}

function db_PutTitleDescriptionObject($ID, $title, $description)
{
  // Task: update title and description of object with id $ID to
  // $title and $description, return "ok" if no errors occured,
  // "nok" otherwise.
  
  global $allbum_table;
  $tmp = "ok";
  
  $query = "UPDATE $allbum_table SET title = '$title' WHERE id = '$ID'";
  $result = mysql_query($query) or died(mysql_error().$query);
  $query = "UPDATE $allbum_table SET description = '$description' WHERE id = '$ID'";
  $result = mysql_query($query) or died(mysql_error().$query);
  return $tmp;
}

function died($txt)
{
    $tmp = "nok";
    echo "<BR>ERROR:&nbsp;" .$txt. "<BR>";
}

function db_PutPathObject($id,$path)
{
  // Task: for object with id $id, change path field to $path
  // return "ok" if no errors occured, "nok" otherwise.
  
  global $allbum_table;
  $tmp = "ok";
  
  $query = "UPDATE $allbum_table SET path = '$path' WHERE id = '$id'";
  $result = mysql_query($query) or died(mysql_error().$query);
  return $tmp;
}

function db_GetLevel($id)
{
  // Task: for (sub-)album with id $id, return it's 'level' in the tree
  
  global $allbum_table;
  
  $query = "SELECT path FROM $allbum_table WHERE id = '$id'";
  $result = mysql_query($query) or die(mysql_error().$query);
  $result = mysql_result($result,0);
  $path = explode("/", $result);
  return count($path)-2;
}

function db_PutChildrenPath($id,$newdir,$level,$type)
{
  // Task: for all children (and their children etc.) of the (sub-)album
  // with id $id and level $level, update the path field with the new 
  // directory of their (grand grand ..)parent.
  // Return "ok" if no errors occured, "nok" otherwise.

  global $allbum_table;
  $tmp = "ok";

  if (($type == "subalbum") OR ($type == "album")) {
    $query = "SELECT children FROM $allbum_table WHERE id='$id'";
    $result = mysql_query($query) or died(mysql_error().$query);
    $result = mysql_result($result,0);
    $children = explode(",", $result);
    foreach ($children AS $key => $value) {
        $query = "SELECT path FROM $allbum_table WHERE id='$value'";
	$result = mysql_query($query) or died(mysql_error().$query);
        $result = mysql_result($result,0);
	$path = explode("/",$result);
        $path[$level+1] = $newdir;
        $path = implode("/",$path);
        $query = "UPDATE $allbum_table SET path = '$path' WHERE id = '$value'";
        $result = mysql_query($query) or died(mysql_error().$query);
	$type = db_GetType($value);
	$tmp2 = db_PutChildrenPath($value,$newdir,$level,$type);
	if ($tmp2 == "nok") {
		$tmp = "nok";
		break;
	}
    }
  }
  return $tmp;
}

function db_PutParentsPath($id,$newdir,$level,$type)
{
  // Task: for all parents (and their parents etc.) of the sub-album
  // with id $id and level $level, update the path field with the new 
  // directory of their (grand grand) child.
  // Return "ok" if no errors occured, "nok" otherwise.

  $tmp = "ok";
  global $allbum_table;

  if ($type == "subalbum") {
    $query = "SELECT parents FROM $allbum_table WHERE id = '$id'";
    $result = mysql_query($query) or died(mysql_error().$query);
    $result = mysql_result($result,0);
    $parent = explode(",", $result);
    foreach ($parent AS $key => $value) {
        $query = "SELECT thumb_file FROM $allbum_table WHERE id = '$value'";
	$result = mysql_query($query) or died(mysql_error().$query);
        $result = mysql_result($result,0);
	if (ThumbIsIcon($result) === true) {
	    $path = explode("/",$result);
    	    $path[$level] = $newdir;
    	    $path = implode("/",$path);
    	    $query = "UPDATE $allbum_table SET thumb_file = '$path' WHERE id = '$value'";
    	    $result = mysql_query($query) or died(mysql_error().$query);
	    $type = db_GetType($value);
	    $tmp2 = db_PutParentsPath($value,$newdir,$level+1,$type);
	    if ($tmp2 == "nok") {
		$tmp = "nok";
	        break;
	    }
	}
    }
  }
  return $tmp;
}

function db_PutCreateObject($type, $title, $description, $path, $thumb, $obj, $org, $parent_ID, $space, $hidden)
{

  // Task: create new object in database, make directory if creating (sub-)album.
  // Return an array with 0 => "ok" if no error occured, 0 => "nok" otherwise.
  // array[1] is used for the ID of the new object if it is a (sub-)album.

  global $lang;
  global $allbum_table;
  $tmp = "ok";

  if ($type == 'album') {
    
    // Make directory:
    umask(0);
    if ( !mkdir($path,0700) )
      {
        $tmp = "nok";
	echo $lang[sn_allbum_error_create_sub_album];
	return array($tmp);
      }
    
    // Insert table entry:
    $query = "INSERT INTO $allbum_table VALUES (NULL, '$type', '$title', '$description', '$path', '$thumb', NULL, NULL, '$parent_ID', NULL, '0', '0')";
    $result = mysql_query($query) or died(mysql_error().$query);
    $child_id = mysql_insert_id();
    return array($tmp,$child_id);
  }
  
  if ($type == 'subalbum') {
 
	// Make directory:
	umask(0);
	if ( !mkdir($path,0700) )
	{
	  $tmp = "nok";
	  echo $lang[sn_allbum_error_create_sub_album];
	  return array($tmp);
	}
    
    	// Insert table entry:
	$query = "INSERT INTO $allbum_table VALUES (NULL, '$type', '$title', '$description', '$path', '$thumb', NULL, NULL, '$parent_ID', NULL, '0', '0')";
	$result = mysql_query($query) or died(mysql_error().$query);
	if ($tmp == "nok") {
		return array($tmp);
	}
	
	// Save auto-increment id from previous query:
	$child_id = mysql_insert_id();

	// Update parent:
	$query = "SELECT children FROM $allbum_table WHERE id='$parent_ID'";
	$result = mysql_query($query) or died(mysql_error().$query);
	if ($tmp == "nok") {
		return array($tmp);
	}
	$result = mysql_result($result,0);
	if ($result == "") {
	    $result = $result . $child_id;
	}
	else {
	    $result = $result . "," . $child_id;
	}

	$query = "UPDATE $allbum_table SET children = '$result' WHERE id = '$parent_ID'";
	$result = mysql_query($query) or died(mysql_error().$query);
	
	return array($tmp,$child_id);
 }
 
 $objects = array('picture', 'sound', 'movie', 'document', 'unknown');
 
 if ( in_array($type,$objects)) {

	// Insert table entry:
	$query = "INSERT INTO $allbum_table VALUES (NULL, '$type', '$title', '$description', '$path', '$thumb', '$obj' , '$org', '$parent_ID', NULL, '$space', 'hidden')";
	$result = mysql_query($query) or died(mysql_error().$query);

	if ($tmp == "nok") {
	  return array($tmp);
	}

	// Save auto-increment id from previous query:
	$child_id = mysql_insert_id();
	
	// **Update parent:
	
	// * children:
	$query = "SELECT children FROM $allbum_table WHERE id='$parent_ID'";
	$result = mysql_query($query) or died(mysql_error().$query);
	$result = mysql_result($result,0);
	if ($result == "") {
	    $result = $result . $child_id;
	}
	else {
	    $result = $result . "," . $child_id;
	}
	if ($tmp == "nok") {
		return array($tmp);
	}
	$query = "UPDATE $allbum_table SET children = '$result' WHERE id = '$parent_ID'";
	$result = mysql_query($query) or died(mysql_error().$query);
	if ($tmp == "nok") {
		return array($tmp);
	}	
	
	// * thumb (not for direct parent only; for all parents back to main album):
	$thumb2 = db_GetThumb($parent_ID);
	$a = substr_count(db_GetPath($child_id),"/");
	while ($thumb2 == "modules/sn_allbum/empty.gif") {
	    if (ThumbIsIcon($thumb)) {
	    	$temp = $thumb;
	    } else {
		$b = explode("/", db_GetPath($child_id));
		for ($i = 0; $i < $a; $i++) {
		    array_shift($b);
		}
		$b = implode("/", $b);
		$temp = $b . "/" . $thumb;
	    }
	    $query = "UPDATE $allbum_table SET thumb_file = '$temp' WHERE id = '$parent_ID'";
    	    $result = mysql_query($query) or died(mysql_error().$query);
	    if (db_GetType($parent_ID) == 'album') {
		break;
	    }
	    $parent_ID = db_GetParentID($parent_ID);
	    $thumb2 = db_GetThumb($parent_ID);
	    $a = $a-1;
	}
  return array($tmp); 
  }
}

function db_GetNumFilesOption()
{
  // Task: return the value of the configuration option allbum_num_files
  
  global $table_configuration;
  
  $query = "SELECT config_value FROM $table_configuration WHERE config_key='allbum_num_files'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function db_GetConfigOptions()
{
  // Task: return a two dimensional array with for each configuration option
  // (config_key, config_value, description)
  global $table_configuration;
  $query = "SELECT config_key, config_value, description FROM $table_configuration WHERE config_key LIKE 'allbum_%'";
  $result = mysql_query($query) or die (mysql_error().$query);
  for ($i = 0; $array = mysql_fetch_row($result); $i++)
  {
    if ($array[0] != "allbum_gallery_dir") {
	$array2[$i] = $array;
    }
  }
  return $array2;
}

function db_PutConfigOption($config_key, $config_value)
{
  // Task: update configuration key $config_key with value
  // $config_value
  global $table_configuration;
  $query = "UPDATE $table_configuration SET config_value = '$config_value' WHERE config_key = '$config_key'";
  $result = mysql_query($query) or die(mysql_error().$query);
}

function illegal_chars($string)
{
  // Task: return true if $string contains an illegal character,
  // return false otherwise.
  // Illegal characters are: >, <, /, \, &, $, [, ], ', `, ",  %
  if ( (strstr($string,">") == false) AND
       (strstr($string,"<") == false) AND
       (strstr($string,"/") == false) AND
       (strstr($string,"\\") == false) AND
       (strstr($string,"&") == false) AND
       (strstr($string,"$") == false) AND
       (strstr($string,"[") == false) AND
       (strstr($string,"]") == false) AND
       (strstr($string,"'") == false) AND
       (strstr($string,"`") == false) AND
       (strstr($string,"\"") == false) AND
       (strstr($string,"%") == false) ) {
    return false;
  } else {
    return true;
  }
}

function MoveObject($objectid,$destinationid)
{
  // Task: move object with id $objectid, including all it's
  // contents to (sub-)album with id $destinationid
  // Return array(succes,message), where success is "ok" in
  // case no error has occured, "nok" otherwise. In case of
  // "nok", an error message must be put in 'message'.
  // Note: moving (sub-)albums has not been implemented.
  
  global $lang;
  
  $type = db_GetType($objectid);
  
  $objects = array('picture','sound','movie','doc','unknown');
  
  if (in_array($type,$objects)) {
    // *file*
    
    // - get full path to file of $objectid
    $objectidthumb = db_GetThumb($objectid);
    $source = str_replace("//","/",db_GetPath($objectid) . "/" . $objectidthumb);
    
    // - get path to directory of $destinationid
    $destinationidpath = db_GetPath($destinationid);
    $destination = str_replace("//","/",$destinationidpath ."/" . $objectidthumb);
    
    // - check if a file with that name does already exists:
    if (file_exists($destination)) {
	$succes = "nok";
	$message = $lang[sn_allbum_move_file_error_exists];
	return array($succes,$message);
    }
    
    // - move file to destination:
    if (rename($source,$destination)) {
	$succes = "ok";
	$message = "";
    } else {
	$succes = "nok";
	$message = $lang[sn_allbum_move_file_error];
    }

    // - update the children field of the old parent of $objectid:
    $objectidparentid = db_GetParentID($objectid);
    UpdateParentListOfChildren($objectid,$objectidparentid);
    
    // - update $objectid's parents field:
    db_PutParents($objectid,$destinationid);  
    
    // - update $objectid's path:
    db_PutPathObject($objectid,$destinationidpath);
    
    // - update $destinationid's children field:
    $children = db_GetChildren($destinationid);
    if ($children == "") {
	$children = array();
    } else {
	$children = explode(",",$children);
	$children = array_clean($children,"");
    }
    array_push($children,$objectid);
    db_PutChildren($destinationid,implode(",",$children));

    // - the thumbnail of $objectid's previous parent might be 
    //   empty now, try to find a new one:
    db_PutIfNeededUpdateParentThumb($objectidparentid);
    
    // - the thumbnail of $destinationid might be empty,
    //   we have a candidate now, so we might need to update it:
    db_PutIfNeededUpdateParentThumb($destinationid);
    
    return array($succes,$message);

  }

  $objects = array('album','subalbum');
  
  if (in_array($type,$objects)) {

    // *(sub-)album*

    $succes = "nok";
    $message = "Moving (sub-)albums has not yet been implemented.";

    // - get path of $objectid
    //$source = db_GetPath($objectid);
    
    // - get path to directory of $destinationid
    //$destination = db_GetPath($destinationid);
        
    // - move directory to destination:
    //if (rename($source,$destination)) {
	//$succes = "ok";
	//$message = "";
    //} else {
	//$succes = "nok";
	//$message = $lang[sn_allbum_move_dir_error];
    //}

    // update database: children (recursive): path
    
    // update database: own entry: path, parent OR path, parent, type (in case moved to main page)
    
    // update database: old parent: children
    
    // update database: new parent: children

    // - the thumbnail of $objectid's previous parent might be 
    //   empty now, try to find a new one:
    //db_PutIfNeededUpdateParentThumb($objectidparentid);
    
    // - the thumbnail of $destinationid might be empty,
    //   we have a candidate now, so we might need to update it:
    //db_PutIfNeededUpdateParentThumb($destinationid);
    
    return array($succes,$message);

    
  }
  
}

###############################################################################

#### Used by sas_admin,php and/or sas_index.php and/or db_functions.inc.php  ####

function ThumbIsIcon($thumb)
{
  // Task: return true if $thumb is an icon, false otherwise
  if ( 	($thumb == "modules/sn_allbum/empty.gif") OR
	($thumb == "modules/sn_allbum/doc_icon.gif") OR
	($thumb == "modules/sn_allbum/document.gif") OR 
	($thumb == "modules/sn_allbum/movie.gif") OR
	($thumb == "modules/sn_allbum/sound.gif") OR
	($thumb == "modules/sn_allbum/unknown.gif")  ) {
	return true;
  } else {
  	return false;
  }
}

function db_GetHidden($ID)
{
  // Task: return the value of the hidden field for the object
  // with id $ID
  
  global $allbum_table;
  
  $query = "SELECT hidden FROM $allbum_table WHERE id = '$ID'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function db_GetType($ID)
{
  // Task: return type of object with id $ID
  
  global $allbum_table;
  
  if ($ID == 0) {
    return 'main';
  } else {
    $query = "SELECT type FROM $allbum_table WHERE id='$ID'";
    $result = mysql_query($query) or die (mysql_error().$query);
    return mysql_result($result,0);
  }
}

function db_GetParentID($ID)
{
  // Task: for object with id $ID, return the id of its parent
  
  global $allbum_table;
  
  $query = "SELECT parents FROM $allbum_table WHERE id='$ID'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function DeleteContents($id)
{
  // Task: delete contents of (sub-)album with id $id
  $contents_array = db_GetContents($id);
  $contents_string = implode(",",$contents_array);
  db_PutDeleteObjects($contents_string);
}

function db_GetContents($ID)
{
  // Task: return the id's for all objects that are
  // located in (sub)-album with id $ID.
  // When $ID = 0, -1 or "", return the id's of all main albums
  
  global $allbum_table;
  
  if (($ID == 0) OR ($ID == "") OR (ID == -1)) {
    $query = "SELECT id FROM $allbum_table WHERE type='album'";
    $result = mysql_query($query) or die (mysql_error().$query);
    $array = array();
    while ($temp = mysql_fetch_array($result)) {
	array_push($array, $temp[0]);
    }
    return $array;
  } else {
    $query = "SELECT children FROM $allbum_table WHERE id='$ID'";
    $result = mysql_query($query) or die (mysql_error().$query);
    $result = mysql_result($result,0);
    $result = explode(",",$result);
    if ($result[0] == "") {
	$result = array();
    }
    return $result;
  }
}

function DeleteDirectory($id)
{
  // Task: delete directory of (sub-)album with object $id
  $path = db_GetPath($id);
  rmdir($path);
}

function db_GetPath($id)
{
  // Task: for object with id $id, return it's path field
  
  global $allbum_table;
  
  $query = "SELECT path FROM $allbum_table WHERE id='$id'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function RemoveDatabaseEntry($id)
{
  // Task: remove database entry of object with id $id
  
  global $allbum_table;
  
  $query = "DELETE FROM $allbum_table WHERE id='$id'";
  $result = mysql_query($query) or die(mysql_error().$query);
}

function DeleteFiles($id)
{
  // Task: delete files for object (not a (sub-)album) with id $id
  
  $file_info = db_GetAllDetails($id);
  // array(type, title, description, path, thumb, obj, org, hidden)

  $thumb = str_replace("//","/",$file_info[3] ."/". $file_info[4]);
  if (file_exists($thumb)) {
  	unlink($thumb);
  }
  
  $obj = str_replace("//","/",$file_info[3] ."/". $file_info[5]);
  if (file_exists($obj)) {
  	unlink($obj);
  }
  
  $org = str_replace("//","/",$file_info[3] ."/". $file_info[6]);
  if (file_exists($org)) {
  	unlink($org);
  }
  
}

function db_GetAllDetails($ID)
{
  // Task: return an array with all details of the object with id $ID:
  // array[type, title, description, path, thumb, obj, org, hidden]
  // If $ID == 0, then the details of a main page are requested. In
  // that case, return array[0 => 'main'].

  global $allbum_table;

  if ($ID == 0) {
  	$result = array('main');
	return $result;
  } else {
  	$query = "SELECT type, title, description, path, thumb_file, object_file, original_file, hidden FROM $allbum_table WHERE id='$ID'";
  	$result = mysql_query($query) or die (mysql_error().$query);
  	$result = mysql_fetch_array($result);
  	return $result;
  }
}

function UpdateParentListOfChildren($ID,$parent)
{
  // Task: remove $ID from the list of children from $ID's 
  // parent with id $parent

  $children = db_GetChildren($parent);
  
  // - remove child from parent's list of children
  $children = explode(",", $children);
  $children = array_clean($children,$ID);
  if (count($children) == 0) { 
	$children = "";
  } else {
	$children = implode(",", $children);
  }

  // - update parent's list of children
  db_PutChildren($parent,$children);
}

function db_GetChildren($ID)
{
  // Task: for object with id $ID, get the list of children,
  // return a string.
  
  global $allbum_table;
  
  $query = "SELECT children FROM $allbum_table WHERE id='$ID'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function db_PutChildren($ID,$children)
{
  // Task: for object with id $ID, put the list of children $children
  
  global $allbum_table;
  
  $query = "UPDATE $allbum_table SET children = '$children' WHERE id='$ID'";
  $result = mysql_query($query) or die(mysql_error().$query);
}

function db_GetParents($ID)
{
  // Task: for object with id $ID, get the list of parents,
  // return a string.
  
  global $allbum_table;
  
  $query = "SELECT parents FROM $allbum_table WHERE id='$ID'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function db_PutParents($ID,$parents)
{
  // Task: for object with id $ID, put the list of parents $parents
  
  global $allbum_table;
  
  $query = "UPDATE $allbum_table SET parents = '$parents' WHERE id='$ID'";
  $result = mysql_query($query) or die(mysql_error().$query);
}

function array_clean ($input, $delete = false, $caseSensitive = false)
{
  // This function has been posted by redshift@pandora.be at 28-Jun-2003 06:01
  // on the following URL: http://nl.php.net/manual/en/function.array-filter.php
  $i = 0;
  while($i < count($input))
        {
        if($delete)
            {
            if($caseSensitive)
                {
                if(!strstr($input[$i] ,$delete))
                    {
                    $return[] = $input[$i];
                    }
                }
                else
                {
                if(!stristr($input[$i], $delete))
                    {
                    $return[] = $input[$i];
                    }
                }
            }
            else
            {
            if(!empty($input[$i]))
                {
                $return[] = $input[$i];
                }
            }
        $i++;
        }
  return $return;
}

function db_GetSomeDetails($ID)
{
  // Task: return an array with (type, title, description, path, thumbfile) for object with id $ID

  global $allbum_table;

  $query = "SELECT type, title, description, path, thumb_file FROM $allbum_table WHERE id='$ID'";
  $result = mysql_query($query) or die (mysql_error().$query);
  $result = mysql_fetch_array($result);
  return $result;
}

function db_GetThumb($ID)
{
  // Task: return thumb field of object with id $ID
  
  global $allbum_table;
  
  $query = "SELECT thumb_file FROM $allbum_table WHERE id='" . $ID . "'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function db_PutIfNeededUpdateParentThumb($parent)
{
  // Task: if the thumbnail field of $parent points to a non-existing
  // image, try to find a new candidate. If it can't be found, use
  // the empty.gif icon.
  // Make sure this is done for all parents (recursion), until 
  // a parent is found that does not need to be updated.
  
  $path = db_GetPath($parent);
  $thumb = db_GetThumb($parent);
  
  if (!file_exists(str_replace("//","/",$path ."/". $thumb))) {
    // try to find another candidate (might be available in a sub-album):
    // - get contents of this parent:
    $contents_array = db_GetContents($parent);
    // - if contents is empty, no candidate can be found:
    $candidate = "";
    if (count($contents_array) != 0) {
	// - a candidate exists, use (if it exists) the first one that has not the empty icon :
	$i = 0;
	while ($i < count($contents_array)) {
	    if ( db_GetThumb($contents_array[$i]) != "modules/sn_allbum/empty.gif" ) {
		$candidate = $contents_array[$i];
		break;
	    }
	    $i++;
	}
    }
    if ($candidate == "") {
	// no candidate available, use empty.gif:
	db_PutThumb($parent,"modules/sn_allbum/empty.gif");
    } else {
	// use new candidate:
	// - get full path of this candidate's thumb:
	$candidate_path = db_GetPath($candidate);
	$candidate_thumb = db_GetThumb($candidate);
	// - check if it has an icon as thumb:
	if (ThumbIsIcon($candidate_thumb)) {
	    // * use it directly
	    db_PutThumb($parent,$candidate_thumb);
	} else {
	    // * calculate thumb_file field for parent
	    // - put it in an array:
	    $candidate_full = $candidate_path ."/". $candidate_thumb;
	    $candidate_full = str_replace("//","/",$candidate_full);
	    $candidate_full_array = explode("/",$candidate_full);
	    // - compare it with parent's path, to calculate what must
	    //   be put in parent's thumb_file field:
	    $length_parent_path = count(explode("/",$path));
	    $candidate_full_array = array_reverse($candidate_full_array);
	    for ($i = 1; $i <= $length_parent_path; $i++) {
		array_pop($candidate_full_array);
	    }
	    $parent_new_thumb_array = array_reverse($candidate_full_array);
	    $parent_new_thumb = implode("/",$parent_new_thumb_array);
	    db_PutThumb($parent,$parent_new_thumb);
	}
    }
    // do the same for parent's parent:
    if (db_GetType($parent) != "album") {
	$new_parent = db_GetParentID($parent);
	db_PutIfNeededUpdateParentThumb($new_parent);
    }
  }
  
}

function db_PutThumb($id,$thumb)
{
  // Task: for object with id $id, update thumb_file field with $thumb
  
  global $allbum_table;
  
  $query = "UPDATE $allbum_table SET thumb_file = '$thumb' WHERE id = '$id'"; 
  mysql_query($query) or die(mysql_error().$query);
}

function db_GetNumObjectsRow() 
{
  // Task: return the value of the configuration option allbum_num_objects_per_row
  
  global $table_configuration;
  
  $query = "SELECT config_value FROM $table_configuration WHERE config_key='allbum_num_objects_per_row'";
  $result = mysql_query($query) or die (mysql_error().$query);
  return mysql_result($result,0);
}

function UpdateDatabaseAlbumOrd()
{
  // Task: check parent field for main albums; if the list does not
  // start with 1 and is ascending without gaps, correct this such
  // that the albums are ordered in the same order.
  
  $mainalbums = db_GetContents(0);
  $albumparentarray = array();
  foreach($mainalbums AS $key => $value) {
    $albumparentarray[$value] = db_GetParentID($value);
  }
  asort($albumparentarray);
  $i = 1;
  foreach($albumparentarray AS $key => $value) {
    if ($i != $value) {
	$albumparentarray[$key] = $i;
    }
    $i++;
  }
  foreach($albumparentarray AS $key => $value) {
    db_PutParents($key,$value);
  }
}

?>
