<?php


###############################################################################
#                    ALLbum-0.1.0: sas_index.php                              #
#                  (visitor interface component)                              #
#                                                                             #
# ALLbum-0.1.0 is a development version of the ALLbum gallery.                #
# It is also available as a module for the Content Management System          #
# "Site@School"  (http://siteatschool.sourceforge.net).                       #
#                                                                             #
# ALLbum is hosted at http://sasmodulesi.sourceforge.net                      #
# ALLbum is written by Martin Herrman <m.herrman@student.tue.nl>              #
# ALLbum is copyrighted by OBS Rosa Boekdrukker, Amsterdam, The Netherlands   #
# (http://www.rosaboekdrukker.nl)                                             #
# ALLbum is licenced by GNU General Public Licence                            #
#                                                                             #
###############################################################################
#                                                                             #
#                            LICENCE INFORMATION                              #
#                                                                             #
# Copyright (c) 2003, OBS Rosa Boekdrukker, Amsterdam, The Netherlands.       #
#                                                                             #
# This program is free software, you can redistribute it and/or               #
# modify it under the terms of the GNU General Public License                 #
# as published by the Free Software Foundation; either version 2              #
# of the License, or (at your option) any later version.                      #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        #
# See the GNU General Public License for more details.                        #
#                                                                             #
# You should hvae received a copy of the GNU General Public License           #
# along with this program; if not, write to the Free Software                 #
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. #
#                                                                             #
###############################################################################

// include database functions:
include($serverpath . "/modules/sn_allbum/db_functions.inc.php");

// use language file if available, use English by default:
if(file_exists($serverpath . "/languages/$language/sn_allbum/$language.php")) {
	include($serverpath . "/languages/$language/sn_allbum/$language.php");
} else {
	include($serverpath . "/languages/EN/sn_allbum/EN.php");
}

// determine what object to show:
if( IsSet($_GET[ID]) AND IsSet($_GET[gallerypage]) ) {
    ShowContent($_GET[ID], $_GET[gallerypage]);
} else {
    ShowContent(0, 1);
}

###############################################################################


function ShowContent($ID, $gpage)
{
     
    // Task: show object with ID $ID, unless it is a hidden object.
    // - When $ID = 0, then a main page must be shown;
    // - When $ID is a (sub-)album, it's contents must be shown;
    // - When $ID is not a (sub-)album or a main page, $gpage is -1. Otherwise,
    //   $gpage is the page number that must be shown.
    
    global $lang;
    global $page;
    global $section;
    global $navpath;
    
    // Get all details:
    // array[type, title, description, path, thumb, obj, org, hidden]
    $details = db_GetAllDetails($ID);
    
    // Check if object is hidden:
    if ($details[7] == 1) {
   	// Show 'object is hidden' page:
	echo "<p><span class=\"heading\">" .$lang[sn_allbum_object_hidden]. "</span></p>";
	echo "<p><span class=\"text\">" .$lang[sn_allbum_object_hidden_text]. "</span></p>";
    	return 0;
    }
    
    $objects = array('sound', 'movie', 'doc', 'unknown');
    
    if (in_array($details[0], $objects)) {
    
    // **sound-file, movie-file, document-file, unknown-file**

	// calculate next and previous picture:
	$albumcontents = array_clean(explode(",",$_GET[contents]),"");
	$i = 0;
	while ($albumcontents[$i] != $ID) {
		$i++;
	}
	if ($i == count($albumcontents)-1) {
	    $nextobjectid = $albumcontents[0];
	} else {
	    $nextobjectid = $albumcontents[$i+1];
	}
	if ($i == 0) {
	    $prevobjectid = $albumcontents[count($albumcontents)-1];
	} else {
	    $prevobjectid = $albumcontents[$i-1];
	}

	// Show page (navpath, title, icon, download link, description):
	ShowNavPath($_GET[navpath]);
	$iconpath = str_replace("//","/","starnet/".$details[4]);
	$filepath = str_replace("//","/","starnet/".$details[3]."/".$details[5]);
	echo "<table width=\"95%\" align=\"center\" border=\"0\">";
	echo "<tr>";
	echo "<td align=\"center\">";
	echo "<a href=\"index.php?page=".$page."&navpath=".$_GET[navpath]."&contents=".$_GET[contents]."&section=".$section."&ID=".$prevobjectid."&gallerypage=1\"><img border=\"0\" title=\"".$lang[sn_allbum_previous_object]."\" src=\"starnet/modules/sn_allbum/nav_prev_icon.gif\"></a>";
	echo "</td><td align=\"center\">";
	echo "	<p><span class=\"heading\">" .$details[1]. "</span></p>";
	echo "  <img src=\"".$iconpath."\">";
	echo "  <div align=\"center\"><p><span class=\"link\"><a href=\"".$filepath."\">" .$lang[sn_allbum_download_file]. "</a></span></p></div>";
	echo "  <div align=\"left\"><p><span class=\"text\">" .$details[2]. "</span></p></div>";
	echo "</td><td align=\"center\">";
	echo "<a href=\"index.php?page=".$page."&navpath=".$_GET[navpath]."&contents=".$_GET[contents]."&section=".$section."&ID=".$nextobjectid."&gallerypage=1\"><img border=\"0\" title=\"".$lang[sn_allbum_next_object]."\" src=\"starnet/modules/sn_allbum/nav_next_icon.gif\"></a>";
	echo "</td>";
	echo "</tr></table>";
	
	return 0;

    
    }
    
    $objects = array('picture');
    
    if (in_array($details[0], $objects)) {
    
    	// **picture**
	
	// Get object size options:
	$width = db_GetPicSizeX();
	
	// calculate next and previous picture:
	$albumcontents = array_clean(explode(",",$_GET[contents]),"");
	$i = 0;
	while ($albumcontents[$i] != $ID) {
		$i++;
	}
	if ($i == count($albumcontents)-1) {
	    $nextobjectid = $albumcontents[0];
	} else {
	    $nextobjectid = $albumcontents[$i+1];
	}
	if ($i == 0) {
	    $prevobjectid = $albumcontents[count($albumcontents)-1];
	} else {
	    $prevobjectid = $albumcontents[$i-1];
	}

	// Calculate width:
	$image = str_replace("//","/","starnet/". $details[3] ."/". $details[4]);
	$size = getimagesize($image);
	if ($size[0] < $size[1]) {
	    // portrait:
	    $width = $width / 1.3;
	} else {
	    // landscape:
	    // skip
	}
	
	// Show page (navpath, title, image, description):
	ShowNavPath($_GET[navpath]);
	echo "<table width=\"95%\" align=\"center\" border=\"0\">";
	echo "<tr>";
	echo "<td align=\"center\">";
	echo "<a href=\"index.php?page=".$page."&navpath=".$_GET[navpath]."&contents=".$_GET[contents]."&section=".$section."&ID=".$prevobjectid."&gallerypage=1\"><img border=\"0\" title=\"".$lang[sn_allbum_previous_object]."\" src=\"starnet/modules/sn_allbum/nav_prev_icon.gif\"></a>";
	echo "</td><td align=\"center\" width=\"".$width."\">";
	echo "	<p><span class=\"heading\">" .$details[1]. "</span></p>";
	echo "  <img width=\"" .$width. "\" src=\"". $image ."\">";
	echo "  <div align=\"left\"><p><span class=\"text\">" .$details[2]. "</span></p></div>";
	echo "</td><td align=\"center\">";
	echo "<a href=\"index.php?page=".$page."&navpath=".$_GET[navpath]."&contents=".$_GET[contents]."&section=".$section."&ID=".$nextobjectid."&gallerypage=1\"><img border=\"0\" title=\"".$lang[sn_allbum_next_object]."\" src=\"starnet/modules/sn_allbum/nav_next_icon.gif\"></a>";
	echo "</td>";
	echo "</tr></table>";
	
	return 0;

    }
    
    $objects = array('album', 'subalbum');

    if (in_array($details[0], $objects)) {
    
	// **(sub-)album**

	// Show navigation path:
	ShowNavPath($_GET[navpath]);

	// Show title and description:
	echo "<p><span class=\"heading\">" .$details[1]. "</span></p>";
	echo "<p><span class=\"text\">" .$details[2]. "</span></p>";
	
	// Start table:
	echo "<table width=\"98%\" border=\"0\">";

	// Get the id's of all objects in (sub-)album with id $ID:
	// (an array is returned)
	$contents = db_GetVisibleContents($ID);

	// Check if the list of children is empty:
	$num = count($contents);
	if ($num == 0) {
	    echo "<tr><td colspan=\"2\"><p><span class=\"text\">" .$lang[sn_allbum_empty_album]. "</span></p></td></tr>";
	} else {
	    // Calculate which children should be shown on page $gpage:
	    $show = array();
	    $max_objects_per_page = db_GetMaxObjectsPerPage();
	    for ( 
		    $i = (($gpage-1) * $max_objects_per_page)+1;
		    ($i <= ($gpage * $max_objects_per_page)) AND ($i <= $num);
		    $i++
		)
	    {
		array_push($show,$contents[$i-1]);
	    }
	    
	    // make a ?-dimensional array of $show (depending on the configuration option):
	    $numperrow = db_GetNumObjectsRow();
	    $showmultipledimensions = array_chunk($show,$numperrow);
	    
	    // Show each object:
	    $x = db_GetThumbSizeX();
	    foreach($showmultipledimensions AS $key => $value) {
	    
		// Start row:
		echo "<tr>";
		
		$j = $numperrow;
		$i = 0;
		while ($i < $j) {
		    // Show object (if available):
		    if (IsSet($value[$i])) {
			ShowObject($value[$i],$x,$numperrow,$_GET[navpath].",".$ID,implode(",",$contents));
		    } else {
			// Show empty cell:
			$w = 100/$numperrow;
			echo "<td width=\"".$w."\">&nbsp;</td>";
		    }
		    $i++;
		}

		// End,start row:
		echo "</tr><tr>";

		$i = 0;
		while ($i < $j) {
		    // Show object (if available):
		    if (IsSet($value[$i])) {
			ShowObjectTitle($value[$i]);
		    } else {
			// Show empty cell:
			$w = 100/$numperrow;
			echo "<td>&nbsp;</td>";
		    }
		    $i++;
		}

		// End row:
		echo "</tr>";
		
		// put empty row for some extra space:
		echo "<tr><td colspan=\"".$numperrow."\">&nbsp;</td></tr>";

	    }
	    
	    ShowPreviousNext($_GET[ID],$gpage,$num,$numperrow);	
    
	}
	
	// End table
	echo "</table>";
	
	return 0;
	
    } 
    
    if ($details[0] == 'main') {

	// **main-page**

        // show page title:
        echo "<p><span class=\"heading\">" .$lang[sn_allbum_gallery_main_page]. "</span></p>";

        // start table:
        echo "<table width=\"98%\">";
	      
	// Get list of main albums:
        $contents = db_GetVisibleContents($ID);

        // Check if list of main albums is empty:
	$num = count($contents);
	if ($num == 0) {
	    echo "<tr><td colspan=\"2\"><p><span class=\"text\">" .$lang[sn_allbum_no_main_albums_avail]. "</span></p></td></tr>";
	} else {

            // sort $contents on value of parents field
	    $contents2 = array();
	    foreach($contents AS $key => $value) {
		$ordnum = db_GetParents($value);
		$contents2[$ordnum-1] = $value;
	    }
	    $i = 0;
	    $contents3 = array();
	    foreach($contents2 AS $key => $value) {
		$contents3[$i] = $value;
		$i++;
	    }

	    // Calculate which albums should be shown on page $page:
	    $show = array();
	    $max_objects_per_page = db_GetMaxObjectsPerPage();
	    for ( 
		    $i = (($gpage-1) * $max_objects_per_page)+1;
		    ($i <= ($gpage * $max_objects_per_page)) AND ($i <= $num);
		    $i++
		)
	    {
		array_push($show,$contents[$i-1]);
	    }

	    // Show each album:
	    $x1 = db_GetThumbSizeX();
	    foreach($show AS $key => $value) {
	    
		// Get some details array(type, title, description, path, thumb):
		$details = db_GetSomeDetails($value);

		if (ThumbIsIcon($details[4])) {
		    $path = $details[4];
		    $x2 = "";
		} else {
		    $path = str_replace("//","/",$details[3]."/".$details[4]);
		    $x2 = $x1;
		}

		// Show album:
		echo "<tr>
		        <td align=\"center\" width=\"40%\">
		          <a href=\"index.php?page=" .$page. "&section=" .$section. "&ID=" .$value. "&gallerypage=1\">
			    <img src=\"starnet/" .$path. "\" width=\"" .$x2. "\">
			  </a>
			</td>
			<td width=\"60%\">
			  <p>
			    <span class=\"text\">
			      <STRONG>" .$details[1]. "</STRONG>
			      <BR><BR>
			      " .$details[2]. "
			    </span>
			  </p>
		        </td>
		      </tr>";
	    }
	    
	    ShowPreviousNext($_GET[ID],$gpage,$num,2);

	}
	// End table:
        echo "</table>";

	return 0;

    }
} 

function ShowObject($id,$x,$numperrow,$navpath,$contents) 
{
  // Task: render image cell for object with id $ID within a row in a (sub)-album.

  global $page;
  global $section;
  global $lang;

  // Get some details array(type, title, description, path, thumb) for first object:
  $details = db_GetSomeDetails($id);
		
  if (ThumbIsIcon($details[4]) == true) {
    $path = $details[4];
    $thumb = true;
  } else {
    $path = str_replace("//","/",$details[3]."/".$details[4]);
  }

  $w = 100/$numperrow;
  $image = "starnet/" .$path;
  $size = getimagesize($image);
  if ($size[0] < $size[1]) {
    // portrait image
    $x = $x/1.3;
  } else {
    // landscape image
  }
  if ($thumb) {
    $x = "";
  }
  echo "<td align=\"center\" width=\"".$w."%\">
	    <a href=\"index.php?page=" .$page. "&navpath=" .$navpath. "&contents=".$contents."&section=" .$section. "&ID=" .$id. "&gallerypage=1\">
		<img src=\"" .$image. "\" width=\"" .$x. "\">
	    </a>
	</td>";
}

function ShowObjectTitle($id)
{
  // Task: render cell for object with id $id within a row in a (sub)-album.
  // Only show the title below the thumbnail.

  global $lang;

  // Get some details array(type, title, description, path, thumb) for first object:
  $details = db_GetSomeDetails($id);
		
  echo "<td align=\"center\">
	    
	    <p><span class=\"text\">";
	    if ($details[0] == "subalbum") {
		echo "<STRONG>".$lang[sn_allbum_album].": " .$details[1]. "</STRONG>";
	    } else {
		echo $details[1];
	    }
	    echo "</span>
	    </p>
	</td>";
}

function ShowPreviousNext($id, $current_page, $numobjects, $numperrow)
{
  // Task: render previous and next images for navigation if previous and next
  // page exists in (sub)-album.
  
  global $page;
  global $section;
  global $navpath;
  
  // Get maximal number of objects per page from database. Use $current_page 
  // and $numobjects to calculate if previous and next pages exist.

  if ($current_page > 1) { 
	$previous_exists = "true" ;
	$prev = $current_page - 1;
  } else {
	$previous_exists = "false" ;
  }

  $maxperpage = db_GetMaxObjectsPerPage();
  if ($current_page * $maxperpage < $numobjects) {
	$next_exists = "true";
	$next = $current_page + 1;
  } else {
	$next_exists = "false" ;
  }

  // Calculate the highest page number:
  $highest = round(ceil($numobjects / $maxperpage));

  echo "<tr><td colspan=\"$numperrow\" align=\"center\">";
  
  if ($previous_exists == "true") {
	echo "<a href=\"index.php?page=" .$page . "&section=" .$section . "&ID=" .$id . "&navpath=".$_GET[navpath]."&gallerypage=" .$prev . "\"><img border=\"0\" src=\"starnet/modules/sn_allbum/nav_prev_icon.gif\"></a>";
  } else {
	echo "<img border=\"0\" src=\"starnet/modules/sn_allbum/nav_dummy.gif\">";
  }
  
  $i = 1;
  echo "&nbsp;";
  while ($i <= $highest) {
    if ($i == $current_page) {
	$showi = "<font color=\"green\">[".$i."]</font>";
    } else {
	$showi = "[".$i."]";
    }
    echo "<span class=\"link\"><a href=\"index.php?page=" .$page . "&navpath=".$_GET[navpath]."&section=" .$section . "&ID=" .$id . "&gallerypage=" .$i. "\">".$showi."</a></span>";
    echo "&nbsp;";
    $i++;
  }
  
  if ($next_exists == "true") {
	echo "<a href=\"index.php?page=" .$page . "&section=" .$section . "&ID=" .$id . "&navpath=".$_GET[navpath]."&gallerypage=" .$next . "\"><img border=\"0\" src=\"starnet/modules/sn_allbum/nav_next_icon.gif\"></a>";	    
  } else {
	echo "<img border=\"0\" src=\"starnet/modules/sn_allbum/nav_dummy.gif\">";
  }
  
  echo "</td></tr>";	
  
}

function ShowNavPath($navpath)
{
  // Task: show navigation path containing links to object
  // id's in $navpath. $navpath is a list, were items are
  // seperated by a ','.
  
  global $lang;
  
  // convert to an array and remove empty elements:
  $navpath = explode(",",$navpath);
  $navpath = array_clean($navpath,"");
  
  // start output:
  echo "<p><span class=\"link\">".$lang[sn_allbum_return_to];
  
  // show link to main page:
  global $page;
  global $section;
  echo "<a href=\"index.php?page=".$page."&section=".$section."\">Main</a>";
  
  // show other links:
  if (IsSet($navpath)) {
    foreach($navpath AS $key => $value) {
	$title = db_GetTitle($value);
	$newnavpath = $navpath;
	$newnavpath = array_clean($newnavpath,"");
	$tmp = array();
	for ($i = 0; $i == $key-1; $i++) {
	    array_push($tmp,$newnavpath[$i]);
	}
	if ($tmp != "") {
	    $newnavpath = implode(",",$tmp);
	}
	echo " -> <a href=\"index.php?page=".$page."&section=".$section."&navpath=".$newnavpath."&ID=".$value."&gallerypage=1\">".$title."</a>";
    }
  }
  
  // end output:
  echo "</span></p>";
  
}
   
?>
